local DALoot = _G.DALoot
local FontStrings={}
local FontFile
local SM = LibStub:GetLibrary("LibSharedMedia-3.0")

--First thing first need to add fonts
SM:Register("font", "ABF",		[[Interface\AddOns\DALoot\Fonts\ABF.ttf]])

function DALoot:AddFontString(string)
	local Font, Height, Flags

	FontStrings[#FontStrings+1]=string

	if not FontFile and DALoot.db.profile.Font then
		FontFile=SM:Fetch("font",DALoot.db.profile.Font)
	end

	if FontFile then
		Font, Height, Flags = string:GetFont()
		if Font~=FontFile then
			string:SetFont(FontFile, Height, Flags)
		end
	end
end

function DALoot:SetFont(fontname)
	local Height, Flags

	DALoot.db.profile.Font=fontname
	FontFile=SM:Fetch("font",fontname)

	for _, v in pairs(FontStrings) do
		_, Height, Flags = v:GetFont()
		v:SetFont(FontFile, Height, Flags)
	end
end