-- Author      : jkonkle
-- Create Date : 7/4/2009 8:58:25 PM
local me={}

function DALoot:CreateRow(num, playerName)
	local rowmin = 1
	local offs = 0

	if not DALoot.db.profile.MainWindow.HideTotalBar then
		offs = 1
		rowmin = 0
	end

	if num<rowmin or DALoot.MainWindow.Rows[num] then
		return
	end
	
	--local row=CreateFrame("CheckButton","DALoot_MainWindow_cb"..num,DALoot.MainWindow)
	--row:SetPoint("TOPLEFT",DALoot.MainWindow,"TOPLEFT",2,-32-(DALoot.db.profile.MainWindow.RowHeight+DALoot.db.profile.MainWindow.RowSpacing)*(num-1+offs))
	--row:SetHeight(DALoot.db.profile.MainWindow.RowHeight)
	--row:SetWidth(DALoot.MainWindow:GetWidth()-4)
	
	local row=CreateFrame("CheckButton","Player_cb"..num,DALoot.MainWindow)
	row:SetWidth(20)
	row:SetHeight(20)
	row:SetPoint("TOPLEFT",DALoot.MainWindow,"TOPLEFT",2,-32-(DALoot.db.profile.MainWindow.RowHeight+DALoot.db.profile.MainWindow.RowSpacing)*(num-1+offs))
	
	row:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up")
	row:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down")
	row:SetDisabledCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check-Disabled")
	row:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check")
	row:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight")
	--row.Text=row:CreateFontString(nil,"OVERLAY","GameFontNormal")
	row.Text=CreateFrame("Button", "playerTextFrame"..num, DALoot.MainWindow) --, "ActionBarButtonTemplate")
	row.Text:SetWidth(50)
	row.Text:SetHeight(20)
	row.Text:SetNormalFontObject("GameFontNormal")
	--
	row.Text:SetText(playerName)
	row.Text:SetPoint("LEFT",row,"RIGHT",8,0)
	row.Text:Show()
	row.Text:SetFrameLevel( DALoot.MainWindow:GetFrameLevel() + 11)
	row:SetFrameLevel( DALoot.MainWindow:GetFrameLevel() + 11)
	if num ~= 0 then
		row:SetScript("OnClick",function(this) 
				if this:GetChecked() then 
					this:SetChecked(true)
					DALoot.db.char.PlayerLoot[this.Text:GetText()][1]=true
				else 
					this:SetChecked(false) 
					DALoot.db.char.PlayerLoot[this.Text:GetText()][1]=false
				end;  end)	
		row.Text:SetScript("OnEnter", function(self) GameTooltip:SetOwner(self, "ANCHOR_TOPRIGHT");DALoot:ShowPlayerDataTooltip(self:GetText());GameTooltip:Show() end)
		row.Text:SetScript("OnLeave", function(self) GameTooltip:Hide() end)
		--row:SetScript("OnLoad", function(self) getglobal(this:GetName().."Text"):SetText("CheckButton1"); end)
		row.Text:EnableMouse(true)
		row:EnableMouse(true)
		row:RegisterForClicks("LeftButtonDown","RightButtonUp")
	else
		row:EnableMouse(false)
	end
	
	DALoot.MainWindow.Rows[num]=row
	DALoot.MainWindow.RowsCreated=num
	--DALoot:UpdateBarTextColor(num)
	--getglobal("DALoot_MainWindow_cb"..num.."Text"):SetText(playerName); 

	-- Update their checkbox to checked...
	if (DALoot.db.char.PlayerLoot[playerName][1] == true) then
		row:SetChecked(true)
	end
	-- TODO: Add code to toggle checkbox and table
	
	DALoot.MainWindow.Rows[num]:Show()
	DALoot.MainWindow.Rows[num].Text:Show()
	row.id=num
end

function DALoot:AddPlayerCheckbox(AceGUI, parent, player)
	local cbPlayer = AceGUI:Create("CheckBox")
	cbPlayer:SetLabel(player)
	parent:AddChild(cbPlayer)
end

function DALoot:ShowReport()
	for index,value in pairs(DALoot.data.Players) do
		   DALoot:Notify(index)
	end
end

function DALoot:UpdateRow(num, playerName)
	--if (num < DALoot.MainWindow.RowsCreated) then
	if (DALoot.MainWindow.Rows[num] ~= nil) then
		self:DebugMsg("Recycling Row for "..playerName)
		local row = DALoot.MainWindow.Rows[num]
		row:Show()
		row.Text:Show()
		row.Text:SetText(playerName)
		if (DALoot.db.char.PlayerLoot[playerName][1] == true) then
			row:SetChecked(true)
		else 
			row:SetChecked(false)
		end
		DALoot.MainWindow.Rows[num]:Show()
		DALoot.MainWindow.Rows[num].Text:Show()
	else
		self:CreateRow(num, playerName) 
	end
end

function DALoot:UpdatePlayers()
	local lPlayers = {} -- DALoot.data.Players
	DALoot.db.char.PlayerLoot = DALoot.db.char.PlayerLoot or {}
		
	--local oldPlayers = DALoot.data.Players
	local name=""
	
	-- Hide all the rows firstly...
	local i = 1
	while (DALoot.MainWindow.Rows[i] ~= nil) do
		DALoot.MainWindow.Rows[i]:Hide()
		DALoot.MainWindow.Rows[i].Text:Hide()
		i=i+1
	end
	
	-- Then add everyone...
	if (GetNumRaidMembers() > 0) then -- you are included in raid members
		local raidMemberString = "raid"
		for i = 1, GetNumRaidMembers(), 1 do
			name = GetRaidRosterInfo(i)
			if (name ~= nil) then 
				lPlayers[name] = true
			end
		end
	elseif (GetNumPartyMembers() > 0) then
		name = UnitName("player")
		lPlayers[name] = true
		local partyMemberString = "party"
		for i = 1, GetNumPartyMembers(), 1 do
			partyMemberString = "party" --reset string		
			partyMemberString = partyMemberString .. i --add the suffix of corresponding player
			name = UnitName(partyMemberString)
			lPlayers[name] = true
		end
	else -- by yourself
		name = UnitName("player")
		lPlayers[name] = true
	end
	DALoot.data.Players = lPlayers
	self:DebugMsg("Player rows: "..#DALoot.data.Players)
	i=1
	for index,value in pairs(DALoot.data.Players) do
		--Update Player Loot table if player isn't there yet.
		if (DALoot.db.char.PlayerLoot[index] == nil) then
			DALoot.db.char.PlayerLoot[index] = {false, 0, 0, 0, 0, 0, 0, {}}
		end
		
		--Create their row
		self:UpdateRow(i, index)	
		i=i+1
	end
end

function DALoot:ResetData()
   DALoot.data.Players = {}  -- Dump the player data hard...
   DALoot.db.char.PlayerLoot={} -- Dump the player loot data
   self:UpdatePlayers() -- Reset the player data
end

function DALoot:CreateMainWindow()
	DALoot.MainWindow=DALoot:CreateFrame("DALoot_MainWindow","DALoot",140,200, function() DALoot.db.profile.MainWindowVis=true end, function() DALoot.db.profile.MainWindowVis=false end)
	DALoot.MainWindow.RowsCreated = 0
	local theFrame=DALoot.MainWindow

	theFrame:SetResizable(true)
	theFrame:SetMinResize(140,63)
	theFrame:SetMaxResize(400,520)		

	theFrame.SaveMainWindowPosition = DALoot.SaveMainWindowPosition
	
	theFrame.SavePosition=DALoot.SaveMainWindowPosition
	DALoot:RestoreMainWindowPosition(DALoot.db.profile.MainWindow.Position.x,DALoot.db.profile.MainWindow.Position.y,DALoot.db.profile.MainWindow.Position.w,DALoot.db.profile.MainWindow.Position.h)
	
	if not DALoot.db.profile.MainWindowVis then
		theFrame:Hide()
	end
end

function DALoot:SaveMainWindowPosition()
	local xOfs, yOfs = self:GetCenter()  -- Elsia: This is clean code straight from ckknight's pitbull
	local s = self:GetEffectiveScale()
	local uis = UIParent:GetScale()
	xOfs = xOfs*s - GetScreenWidth()*uis/2
	yOfs = yOfs*s - GetScreenHeight()*uis/2
	
	DALoot.db.profile.MainWindow.Position.x=xOfs/uis
	DALoot.db.profile.MainWindow.Position.y=yOfs/uis
	DALoot.db.profile.MainWindow.Position.w=self:GetWidth()
	DALoot.db.profile.MainWindow.Position.h=self:GetHeight()
end

function DALoot:RestoreMainWindowPosition(x, y, width, height)
	local f = DALoot.MainWindow
	local s = f:GetEffectiveScale() -- Elsia: Fixed position code, with inspiration from ckknight's handing in pitbull
	local uis = UIParent:GetScale()
	f:SetPoint("CENTER", UIParent, "CENTER", x*uis/s, y*uis/s)
	f:SetWidth(width)
	f:SetHeight(height)
	f:SavePosition()
end

function DALoot:ShowPlayerDataTooltip(playerName)
	-- {false,  1 = Has used Priority
	-- 0,		2 = Priority Wins
	-- 0,		3 = Priority Rolls
	-- 0,		4 = Main Wins
	-- 0,		5 = Main Rolls
	-- 0,		6 = Off Wins
	-- 0,		7 = Off Rolls
	-- {}}		8 = Loot wins table
	GameTooltip:ClearLines()
	GameTooltip:AddLine(playerName)
	local playerData = DALoot.db.char.PlayerLoot[playerName]
	GameTooltip:AddLine("Priority Wins: "..playerData[2].."/"..playerData[3])
	GameTooltip:AddLine("Main Spec Wins: "..playerData[4].."/"..playerData[5])
	GameTooltip:AddLine("Off Spec Wins: "..playerData[6].."/"..playerData[7])
	
	-- {rollCat, self.data.strItem}
	if (#playerData[8] > 0) then
		GameTooltip:AddLine("")
		for index,value in pairs(playerData[8]) do
			GameTooltip:AddLine(value[1].." "..value[2])
		end
	end
end

function DALoot:CheckPriorityBox(player)
	local i = 1
	while (DALoot.MainWindow.Rows[i] ~= nil) do
		if (DALoot.MainWindow.Rows[i].Text:GetText() == player) then
			DALoot.MainWindow.Rows[i]:SetChecked(true)
		end
		i=i+1
	end
end