-- Author      : jkonkle
-- Create Date : 6/23/2009 1:59:28 PM
-- Functions that handle the loot and management and results

function DALoot:ManualActivate(item)
	self:Print("Starting rolling on "..item)
	local dist = "PARTY"
	if (GetNumRaidMembers() > 0) then
		dist = "RAID"
	end
	self:SendCommMessage("DA_LOOT_ROLL", item, dist)

	self:BeginRolling(item)
end

function DALoot:BeginRolling(item)
    self.data.timerCount = tonumber(self.db.profile.bidTime);
    self.data.strItem=item
    self.data.bDoingLoot=true
    self.data.OMGRolls={}
    self.data.MainRolls={}
    self.data.OffRolls={}
    self.data.playersBid={}
    if (DALoot.db.profile.raidAnnounce) then
        SendChatMessage("NOW ROLLING ON " .. item .. "!", "RAID_WARNING")
    end
    self:Announce("NOW ROLLING ON " .. item .. "!")
    local str = "Offspec '/roll' MainSpec '/roll 200' "
    if (DALoot.db.profile.enablePriority) then
        str = str .. "Priority '/roll 300' "
    end 
    self:Announce(str .. self.db.profile.bidTime .. " secs left to roll!")
    --self:Announce("Remember you can only have 1 Priority roll! " .. self.db.profile.bidTime .. " secs left to roll!  Roll now!  Operators are standing by!")
    self.data.timerBid=self:ScheduleRepeatingTimer("HandleTimer", 1)  -- tick the timer every second
end	

-- HANDLE TIMER
-- This function handles the timer scheduled by the ProcessLoot function.  It iterates through
-- the receved bids and yadda yadda
function DALoot:HandleTimer()
	-- send time to clients...
	local dist = "PARTY"
	if (GetNumRaidMembers() > 0) then
		dist = "RAID"
	end
	self.data.timerCount = self.data.timerCount - 1
	self:SendCommMessage("DA_LOOT_COUNTDOWN", tostring(self.data.timerCount), dist)
	
	if ((self.data.timerCount > 0) and (self.data.timerCount <= tonumber(DALoot.db.profile.countdownTime))) then
		self:Announce(self.data.timerCount)
	end
	if (self.data.timerCount < 1) then
		self:SendCommMessage("DA_LOOT_ROLLEND", " ", dist)
		self:CancelTimer(self.data.timerBid)
		if(not self.data.bDoingLoot) then return end
		self.data.bDoingLoot=false
		
		if((#self.data.OMGRolls==0) and (#self.data.MainRolls==0) and (#self.data.OffRolls==0)) then
			self:Announce("No rolls received.  Item to DE.")
		else
			self:ShowTopResults()
		end
	end
end

