-- Author      : jkonkle
-- Create Date : 7/12/2009 12:21:56 PM

local me={}

function me:CreateRollWindow()
    me.RollFrame=CreateFrame("Frame",nil,UIParent)

    local theFrame=me.RollFrame

    theFrame:ClearAllPoints()
    theFrame:SetPoint("CENTER",UIParent)
    theFrame:SetHeight(120)
    theFrame:SetWidth(400)

    theFrame:SetBackdrop({
        bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", tile = true, tileSize = 16,
        edgeFile = "Interface\\AddOns\\DALoot\\textures\\otravi-semi-full-border", edgeSize = 32,
        insets = {left = 1, right = 1, top = 20, bottom = 1},
    })
    theFrame:SetBackdropBorderColor(1.0,0.0,0.0)
    theFrame:SetBackdropColor(24/255, 24/255, 24/255)
    DALoot.Colors:RegisterBorder("Other Windows","Title",theFrame)
    DALoot.Colors:RegisterBackground("Other Windows","Background",theFrame)

    theFrame:EnableMouse(true)
    theFrame:SetMovable(true)

    theFrame:SetScript("OnMouseDown", function(this) 
            if ( ( ( not this.isLocked ) or ( this.isLocked == 0 ) ) and ( arg1 == "LeftButton" ) ) then
              --DALoot:SetWindowTop(this)
              this:StartMoving();
              this.isMoving = true;
             end
            end)
    theFrame:SetScript("OnMouseUp", function(this) 
            if ( this.isMoving ) then
              this:StopMovingOrSizing();
              this.isMoving = false;
             end
            end)
    theFrame:SetScript("OnShow", function(this)
            --DALoot:SetWindowTop(this)
            end)

    theFrame:SetScript("OnHide", function(this)
            if ( this.isMoving ) then
              this:StopMovingOrSizing();
              this.isMoving = false;
             end
            end)

    theFrame.Title=theFrame:CreateFontString(nil,"OVERLAY","GameFontNormal")
    theFrame.Title:SetPoint("TOPLEFT",theFrame,"TOPLEFT",6,-15)
    theFrame.Title:SetTextColor(1.0,1.0,1.0,1.0)
    theFrame.Title:SetText("Loot Roll?")
    DALoot:AddFontString(theFrame.Title)

--	DALoot.Colors:UnregisterItem(me.RollFrame.Title)
    DALoot.Colors:RegisterFont("Other Windows", "Title Text", me.RollFrame.Title)

    theFrame.ItemButton = CreateFrame("Button", "DAItemButton", theFrame, "ItemButtonTemplate")
    theFrame.ItemButton:SetPoint("LEFT", theFrame, "LEFT", 10, -2)
    theFrame.ItemButton:SetScript("OnEnter", function(self) GameTooltip:SetOwner(self, "ANCHOR_RIGHT");GameTooltip:SetHyperlink(self.tooltipText); GameTooltip:Show() end)
    theFrame.ItemButton:SetScript("OnLeave", function(self) GameTooltip:Hide() end)

    theFrame.Text=theFrame:CreateFontString("DAItemButtonText","OVERLAY","GameFontNormal")
    theFrame.Text:SetPoint("CENTER",theFrame,"CENTER",0,1)
    theFrame.Text:SetTextColor(1.0,1.0,1.0)
    theFrame.Text:SetText(" ")
    DALoot:AddFontString(theFrame.Text)

    theFrame.Text=theFrame:CreateFontString("DAItemCountdown","OVERLAY","GameFontNormal")
    theFrame.Text:SetPoint("CENTER",theFrame,"CENTER",0,-15)
    theFrame.Text:SetTextColor(1.0,1.0,1.0)
    theFrame.Text:SetText("XX seconds left.")
    DALoot:AddFontString(theFrame.Text)

    theFrame.PriorityButton=CreateFrame("Button",nil,theFrame,"OptionsButtonTemplate")
    theFrame.PriorityButton:SetWidth(90)
    theFrame.PriorityButton:SetHeight(24)
    theFrame.PriorityButton:SetPoint("BOTTOMLEFT",theFrame,"BOTTOMLEFT", 1, 4) --,-8,4)
    theFrame.PriorityButton:SetScript("OnClick",function() RandomRoll(1,300);theFrame:Hide() end)
    theFrame.PriorityButton:SetText("Priority")

    theFrame.MainButton=CreateFrame("Button",nil,theFrame,"OptionsButtonTemplate")
    theFrame.MainButton:SetWidth(90)
    theFrame.MainButton:SetHeight(24)
    theFrame.MainButton:SetPoint("BOTTOM",theFrame,"BOTTOM", -50,4)
    theFrame.MainButton:SetScript("OnClick",function() RandomRoll(1,200);theFrame:Hide() end)
    theFrame.MainButton:SetText("Main")

    theFrame.OffButton=CreateFrame("Button",nil,theFrame,"OptionsButtonTemplate")
    theFrame.OffButton:SetWidth(90)
    theFrame.OffButton:SetHeight(24)
    theFrame.OffButton:SetPoint("BOTTOM",theFrame,"BOTTOM", 50, 4) --,8,4)
    theFrame.OffButton:SetScript("OnClick",function() RandomRoll(1,100);theFrame:Hide() end)
    theFrame.OffButton:SetText("Off")

    theFrame.PassButton=CreateFrame("Button",nil,theFrame,"OptionsButtonTemplate")
    theFrame.PassButton:SetWidth(90)
    theFrame.PassButton:SetHeight(24)
    theFrame.PassButton:SetPoint("BOTTOMRIGHT",theFrame,"BOTTOMRIGHT",-1,4)
    theFrame.PassButton:SetScript("OnClick",function() theFrame:Hide() end)
    theFrame.PassButton:SetText("Pass")

    theFrame:Hide()


    --Need to add it to our window ordering system
    --DALoot:AddWindow(theFrame)
end

function DALoot:ShowRollWindow(item)
    if me.RollFrame==nil then
        me:CreateRollWindow()
    end

    local name, link, quality, iLevel, reqLevel, class, subclass, maxStack, equipSlot, texture, vendorPrice = GetItemInfo(item)
    color = ITEM_QUALITY_COLORS[quality];
    local theItemButton = getglobal("DAItemButton")
    theItemButton.tooltipText = link
    getglobal("DAItemButtonIconTexture"):SetTexture(texture);
    local text = getglobal("DAItemButtonText");
    text:SetText(name);
    if (color ~= nil) then
        text:SetVertexColor(color.r, color.g, color.b);
    end
    --button.quality = quality;	

    me.RollFrame:Show()
end

function DALoot:HideRollWindow()
    if me.RollFrame ~= nill then
        me.RollFrame:Hide()
    end	
end

function DALoot:UpdateWindow(msg)
    if me.RollFrame ~= nill then
        local text = getglobal("DAItemCountdown");
        text:SetText(msg.." seconds left!");
        --me.RollFrame:Update()
    end
end